commit 7d88f924ad8d773cceb08e123cb2831f20d40cb4
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Tue Jul 28 11:08:29 2020 +0200

    expander: Fix ICE in maybe_warn_rdwr_sizes [PR96335]
    
    The following testcase ICEs in maybe_warn_rdwr_sizes.  The problem is that
    the caller uses its fndecl and fntype variables to fill up rdwr_map, and
    the fntype in that case is a prototype with the access attribute and all
    the checks needed for that performed.  But the maybe_warn_rdwr_sizes
    function tries to rediscover fndecl/fntype itself and does it differently
    from how the caller did (for fndecl get_callee_fndecl and fntype from that
    FUNCTION_DECL, otherwise sets fntype to CALL_EXPR_FN's type).
    
    On the testcase, get_callee_fndecl does find a FUNCTION_DECL because
    it does STRIP_NOPS in between.
    
    Instead of trying to rediscover those, this patch just passes them down,
    like is done in several other functions.
    
    2020-07-28  Jakub Jelinek  <jakub@redhat.com>
    
            PR middle-end/96335
            * calls.c (maybe_warn_rdwr_sizes): Add FNDECL and FNTYPE arguments,
            instead of trying to rediscover them in the body.
            (initialize_argument_information): Adjust caller.
    
            * gcc.dg/pr96335.c: New test.
    
    (cherry picked from commit f9264b9008386ac3b5c795472c222fa524b127b0)

diff --git a/gcc/calls.c b/gcc/calls.c
index 8041388c1d2..e0831e9d4b9 100644
--- a/gcc/calls.c
+++ b/gcc/calls.c
@@ -1982,24 +1982,8 @@ append_attrname (const std::pair<int, attr_access> &access,
    in the function call EXP.  */
 
 static void
-maybe_warn_rdwr_sizes (rdwr_map *rwm, tree exp)
+maybe_warn_rdwr_sizes (rdwr_map *rwm, tree fndecl, tree fntype, tree exp)
 {
-  tree fndecl = NULL_TREE;
-  tree fntype = NULL_TREE;
-  if (tree fnaddr = CALL_EXPR_FN (exp))
-    {
-      if (TREE_CODE (fnaddr) == ADDR_EXPR)
-	{
-	  fndecl = TREE_OPERAND (fnaddr, 0);
-	  fntype = TREE_TYPE (fndecl);
-	}
-      else
-	fntype = TREE_TYPE (TREE_TYPE (fnaddr));
-    }
-
-  if (!fntype)
-    return;
-
   /* A string describing the attributes that the warnings issued by this
      function apply to.  Used to print one informational note per function
      call, rather than one per warning.  That reduces clutter.  */
@@ -2560,7 +2544,7 @@ initialize_argument_information (int num_actuals ATTRIBUTE_UNUSED,
   maybe_warn_nonstring_arg (fndecl, exp);
 
   /* Check read_only, write_only, and read_write arguments.  */
-  maybe_warn_rdwr_sizes (&rdwr_idx, exp);
+  maybe_warn_rdwr_sizes (&rdwr_idx, fndecl, fntype, exp);
 }
 
 /* Update ARGS_SIZE to contain the total size for the argument block.
diff --git a/gcc/testsuite/gcc.dg/pr96335.c b/gcc/testsuite/gcc.dg/pr96335.c
new file mode 100644
index 00000000000..ab243b3d129
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/pr96335.c
@@ -0,0 +1,12 @@
+/* PR middle-end/96335 */
+/* { dg-do compile } */
+/* { dg-options "-O2" } */
+
+void bar (int, void *) __attribute__((__access__(__read_only__, 2)));
+
+void
+foo (void *x)
+{
+  void (*fn) () = bar;
+  fn (0, x);
+}

